package com.hai.dao;

import com.hai.entity.OutRechargePrice;
import com.hai.entity.OutRechargePriceExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface OutRechargePriceMapper extends OutRechargePriceMapperExt {
    @SelectProvider(type=OutRechargePriceSqlProvider.class, method="countByExample")
    long countByExample(OutRechargePriceExample example);

    @DeleteProvider(type=OutRechargePriceSqlProvider.class, method="deleteByExample")
    int deleteByExample(OutRechargePriceExample example);

    @Delete({
        "delete from out_recharge_price",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into out_recharge_price (`type`, price, ",
        "real_price, create_time)",
        "values (#{type,jdbcType=INTEGER}, #{price,jdbcType=DECIMAL}, ",
        "#{realPrice,jdbcType=DECIMAL}, #{createTime,jdbcType=TIMESTAMP})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(OutRechargePrice record);

    @InsertProvider(type=OutRechargePriceSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(OutRechargePrice record);

    @SelectProvider(type=OutRechargePriceSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="type", property="type", jdbcType=JdbcType.INTEGER),
        @Result(column="price", property="price", jdbcType=JdbcType.DECIMAL),
        @Result(column="real_price", property="realPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP)
    })
    List<OutRechargePrice> selectByExample(OutRechargePriceExample example);

    @Select({
        "select",
        "id, `type`, price, real_price, create_time",
        "from out_recharge_price",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="type", property="type", jdbcType=JdbcType.INTEGER),
        @Result(column="price", property="price", jdbcType=JdbcType.DECIMAL),
        @Result(column="real_price", property="realPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP)
    })
    OutRechargePrice selectByPrimaryKey(Long id);

    @UpdateProvider(type=OutRechargePriceSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") OutRechargePrice record, @Param("example") OutRechargePriceExample example);

    @UpdateProvider(type=OutRechargePriceSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") OutRechargePrice record, @Param("example") OutRechargePriceExample example);

    @UpdateProvider(type=OutRechargePriceSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(OutRechargePrice record);

    @Update({
        "update out_recharge_price",
        "set `type` = #{type,jdbcType=INTEGER},",
          "price = #{price,jdbcType=DECIMAL},",
          "real_price = #{realPrice,jdbcType=DECIMAL},",
          "create_time = #{createTime,jdbcType=TIMESTAMP}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(OutRechargePrice record);
}